/************************************************************************\
 *	{W: DAYICVT.C						*
 *	]pت: NtjXΤ媺r DAYI.COD ഫ	*
 *		   DAYI.TAB αN DAYI.TAB ഫtj	*
 *		  XΤ媺r DAYI.COD				*
 *	{  : vz (Unicorn)					*
 *	]p: 12-25-1992						*
\************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <alloc.h>

/* wq~NX */
#define F_TAB		0
#define F_COD		1
#define F_TMP		2
#define A_OPT		3
#define A_PARM		4
#define A_SAME		5
#define C_DAYI		6
#define C_BIG5		7
#define P_setvbuf	8
#define P_fseek 	9
#define P_ftell 	10
#define P_malloc	11

/* wqƫA */
union TWOBYTE {
    unsigned i;
    unsigned char byte[2];
};

/* ŧi禡쫬 */
void errexit(int n);
void errquit(unsigned n, int m);
void help(void);
char openfile(int c, char *v[]);
void cod2tab(void);
void tab2cod(void);

/* ŧiܼ */
FILE *fin, *fout;
const static char table[] = {	/* LPCXӪ */
     '', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
    'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U',
    'V', 'W', 'X', 'Y', 'Z', '.', '/', '0', '1', '2', '3',
    '4', '5', '6', '7', '8', '9', ';', ','
};

/***************************************
 *	~BzƵ{
 */
void errexit(int n)
{
    char *errmsg[] = {
	"The binary file can not open",
	"The text file can not open",
	"The temporary file can not open",
	"Invalid option",
	"Too many parameters",
	"Input and output files MUST be different",
	"Invaild DAYI code",
	"Invalid BIG-5 code",
	"setvbuf failed",
	"fseek failed",
	"ftell failed",
	"Not enough memory"
    };

    fprintf(stderr,"Error: %s ...\n", errmsg[n++]);
    exit(n);
}

/***************************************
 *	{椤~BzƵ{
 */
void errquit(unsigned n, int m)
{
    remove("$d$a$y$i.$$$");
    fprintf(stderr,"Line %u ",n);
    errexit(m);
}

/***************************************
 *	ܽuWDUT
 */
void help(void)
{
    fprintf(stderr,
    "\nUsage: DAYICVT  [options]  [input file]  [output file]\n"
    "\n    where option is one of the following.\n\n"
    "\t-T\tConvert the binary file to the text file\n"
    "\t-B\tConvert the text file to the binary file\n"
    "\t-H,-?,? Show this message\n"
    "\nNOTE THAT:\n"
    "    1.\tThe order of the command line parameters do not"
    " have any\n"
    "\tconstraint, except the input file MUST precede the"
    " output file.\n"
    "    2.\tThe default input and output files are DAYI.TAB"
    " and DAYI.COD.\n"
    "    3.\tYou may have many options, but only the last one"
    " is active.\n");
    exit(0);
}

/***************************************
 *	RROCѼƤζ}ɮ
 */
char openfile(int c, char *v[])
{
    char *ext[] = {".COD",".TAB"};
    char oin[] = "rb", oout[3] = "wt";
    char *infile, *outfile, isTAB, ch;
    int i;

    /* ]wJοXɦW̤j */
    if ((infile = (char *)malloc(128*sizeof(char))) == NULL)
	errexit(P_malloc);
    if ((outfile = (char *)malloc(128*sizeof(char))) == NULL)
	errexit(P_malloc);

    /* wJοXɦWw */
    *infile = *outfile = 0;

    /*
     *	}lRROCѼ
     */
    if (c == 1) 			/* pGSѼ */
	help();

    for (i = 1; i < c; i++) {
	/* pGUѼƩέnDuWDUT */
	if (*v[i] == '?' && v[i][1] == 0)
	    help();

	/* pGثeRѼƬ@ӿܶ */
	if (*v[i] == '-' && v[i][2] == 0) {
	    ch = toupper(v[i][1]);
	    if (ch == 'T')              /* pGnDXr */
		isTAB = 0;
	    else if (ch == 'B')         /* pGnDX */
		isTAB = 1;
	    else if (ch == 'H' || ch == '?')    /* pGnDuWDUT */
		help();
	    else			/* pGUѼ */
		errexit(A_OPT);
	}

	/* pGثeRѼƬɦW */
	else if (*infile == 0)		/* pGJɦW|w */
	    strcpy(infile,v[i]);
	else if (*outfile == 0) 	/* pGXɦW|w */
	    strcpy(outfile,v[i]);
	else				/* pGJοXɦWww */
	    errexit(A_PARM);
    }

    /* pGw]wFܶ, ɦW|]w */
    if (*infile == 0) { 		/* pGJɦWw */
	fprintf(stderr,"\n>> Source file : ");
	gets(infile);
	if (*infile == 0) {	/* pGwJɦW, hĥΤwɦW */
	    strcpy(infile,"DAYI");
	    strcat(infile,ext[(isTAB + 1) % 2]);
	}
    }
    if (*outfile == 0) {		/* pGXɥw */
	fprintf(stderr,"\n>> Target file : ");
	gets(outfile);
	if (*outfile == 0) {	/* pGwXɦW, hĥΤwɦW */
	    strcpy(outfile,"DAYI");
	    strcat(outfile,ext[isTAB]);
	}
    }

    /* ˬdJɬO_PXɪɦWۦP */
    if (!stricmp(infile,outfile))
	errexit(A_SAME);

    /* ]wɮ׶}ҪҦ */
    if (isTAB) {
	strcpy(oin,"rt");
	strcpy(oout,"wb");
    }

    /* }ҿJοXɮ */
    if ((fin = fopen(infile,oin)) == NULL)
	errexit(0);
    if ((fout = fopen(outfile,oout)) == NULL)
	errexit(1);

    /* ]wJοXɮ׽wİ */
    if (setvbuf(fin,NULL,_IOFBF,10240) != 0)
	errexit(P_setvbuf);
    if (setvbuf(fout,NULL,_IOFBF,10240) != 0)
	errexit(P_setvbuf);

    fprintf(stderr,"\nConvert [%s] to [%s].\n\nPlease wait a moment ...\n",
	    strupr(infile),strupr(outfile));
    free(outfile);
    free(infile);

    return isTAB;
}

/***************************************
 *	N .TAB ഫiŪr
 */
void tab2cod(void)
{
    unsigned char	hbyte, mbyte, lbyte, code[5];
    unsigned		*dup_w;
    register unsigned	i, hc, lc, dup_num;
    union TWOBYTE	x;
    long		fsize;

    /* Ū .TAB ɭЦrϪЦrӼ, ðOb dup_num  */
    fscanf(fin,"%c%c",&x.byte[0],&x.byte[1]);
    dup_num = x.i;

    /* NЦrϪЦrഫ̧ǰOb dup_w  */
    if ((dup_w = (unsigned *)malloc(dup_num * sizeof(int))) == NULL)
	errexit(P_malloc);
    for (i = 0; i < dup_num; i++) {
	fscanf(fin,"%c%c",&x.byte[1],&x.byte[0]);
	dup_w[i] = x.i - 0x8800;
    }

    /*
     *	XЦrϪjp, :
     *	ЦrϤjp = int( ( dup_num * 2 + 4 ) / 3 ) * 3
     */
    i = (dup_num + dup_num + 4) / 3;
    i += i + i;

    /*
     *	X .TAB ɤҰOr, :
     *	r = (ɮפjp - ЦrϤjp - ɧӦ줸) / 3
     */
    if (fseek(fin,-6,SEEK_END))
	errexit(P_fseek);
    if ((fsize = (ftell(fin) - i) / 3) < 0)
	errexit(P_ftell);

    /* NɮתвĤ@ӽXm */
    if (fseek(fin,i,SEEK_SET))
	errexit(P_fseek);

    code[4] = 0;
    for (i = 0; i < (int)fsize; i++) {
	/*
	 *  ˬdثenѽXr, O_ڭ̭nЦr,
	 *  pGO, hbXe[W@ * O
	 */
	for (hc = 0; (i != dup_w[hc]) && (hc < dup_num); hc++);
	if (hc != dup_num) {
	    fprintf(fout,"*");
	    dup_num--;
	    for (lc = hc; lc < dup_num; lc++)
		dup_w[lc] = dup_w[lc+1];
	}

	/* ŪX, ñNŪrsJ code  */
	fscanf(fin,"%c%c%c", &lbyte, &mbyte, &hbyte);
	code[0] = table[lbyte >> 2];
	code[1] = table[((lbyte & 0x03) << 4) + (mbyte >> 4)];
	code[2] = table[((mbyte & 0x0F) << 2) + (hbyte >> 6)];
	code[3] = table[hbyte & 0x3F];

	/* XXҹr */
	hc = (i < 5401) ? i : i + 408;
	lc = hc % 157;
	lc += (lc < 63) ? 0x40 : 0x62;
	hc = hc / 157;
	hc += 0xA4;

	/* NsXXΨrs */
	fprintf(fout,"%s\t%c%c\n", code, hc, lc);
    }
    free(dup_w);
}

/***************************************
 *	Nrഫ .TAB 
 */
void cod2tab(void)
{
    char		lbyte, mbyte, hbyte, code[4], buf[81],
			ch, flag;
    register unsigned	i, j, lineno = 0;
    union TWOBYTE	x;
    FILE		*temp;

    /* }{ɦs, sCYX */
    if ((temp = fopen("$d$a$y$i.$$$","wb+")) == NULL)
	errexit(F_TMP);
    if (setvbuf(temp,NULL,_IOFBF,10240) != 0)
	errquit(lineno,P_setvbuf);

    fprintf(fout,"%c%c",0,0);           /*  NЦrӼƳ] 0 */

    while (fgets(buf,80,fin)) { 	/*  Ū@ */
	flag = 0;
	lineno++;

	if (*buf != ' ' && *buf != '\n') {      /* ˬdO_Ѧ */

	    /*	pGĤ@Ӧr '*',  hܸӦruЦr */
	    if (*buf == '*')
		flag = 1;

	    /* NjrڽXഫCX
	     */
	    code[1] = code[2] = code[3] = 0;
	    for (i = flag; (buf[i] != '\t') && (buf[i] != ' ') &&
		(buf[i] <= 'z'); i++) {
		ch = toupper(buf[i]);

		/* dO_jrڽX */
		if (!(isalnum(ch) || ch == ';' || ch == ',' ||
		    ch == '.' || ch == '/'))
		    errquit(lineno,C_DAYI);

		/* XCX, æsJ code  */
		for (j = 0; (table[j] != ch) && (j < 41); j++);
		code[i-flag] = j;
	    }

	    if (i > flag + 4)		/* dXӼƬO_WL 4 */
		errquit(lineno,C_DAYI);

	    /* NCXഫCYX */
	    lbyte = (code[0] << 2) + (code[1] >> 4);
	    mbyte = (code[1] << 4) + (code[2] >> 2);
	    hbyte = (code[2] << 6) + code[3];

	    /* Ū@Ӥr */
	    while (buf[++i] < 0xA4);
	    x.byte[1] = buf[i++];
	    x.byte[0] = buf[i];

	    /* dӦrO_Xkr */
	    if (x.byte[0] < 0x40 || x.byte[0] == 0xFF ||
		(x.byte[0] > 0x7E && x.byte[0] < 0xA1))
		errquit(lineno,C_BIG5);
	    else if (x.byte[1] < 0xA4 || x.byte[1] > 0xF9 ||
		(x.i > 0xC67E && x.i < 0xC940))
		errquit(lineno,C_BIG5);
	    else {	/* XӦrb .TAB ɤm */
		i = (x.byte[1] - 0xA4) * 157 + x.byte[0];
		i -= (x.byte[0] > 0xA0) ? 0x62 : 0x40;
		if (x.i > 0xC67E)
		    i -= 408;
	    }

	    /* pGӦruЦr, hNǦCXgJЦr */
	    if (flag) {
		x.i = i + 0x8800;
		fprintf(fout,"%c%c",x.byte[1],x.byte[0]);
	    }

	    /*	NӦrCYXgJ{ɦs */
	    if (fseek(temp,i*3,SEEK_SET))
		errquit(lineno,P_fseek);
	    fprintf(temp,"%c%c%c",lbyte,mbyte,hbyte);
	}
    }

    /* gJЦrӼ, çXĤ@ӦCYXm */
    if ((x.i = ((int)ftell(fout) - 2) / 2) < 0)
	errquit(lineno,P_ftell);
    fprintf(fout,"%c%c",0,0);
    if (fseek(fout,0,SEEK_SET))
	errquit(lineno,P_fseek);
    fprintf(fout,"%c%c",x.byte[0],x.byte[1]);
    i = (x.i + x.i + 4) / 3;
    i += i + i;
    if (fseek(fout,i,SEEK_SET))
	errquit(lineno,P_fseek);

    /* N{ɦsɤCYXgJ .TAB ɤ */
    if (fseek(temp,0,SEEK_END))
	errquit(lineno,P_fseek);
    if ((j = (int)ftell(temp)) < 0)
	errquit(lineno,P_ftell);
    j /= 3;
    if (fseek(temp,0,SEEK_SET))
	errquit(lineno,P_fseek);
    for (i = 0; i < j; i++) {
	fread(code,sizeof(char),3,temp);
	fwrite(code,sizeof(char),3,fout);
    }
    fclose(temp);
    remove("$d$a$y$i.$$$");

    /* N 6  0xFF gJ .TAB ɪɧ */
    if (fseek(fout,0,SEEK_END))
	errexit(P_fseek);
    for (i = 0; i < 6; i++)
	fprintf(fout,"%c",0xFF);
}

/***************************************
 *	D  {	
 */
void main(char argc, char *argv[])
{
    fprintf(stderr,"DAYICVT - DAYI.TAB Convertion Program,"
		   "  Version 12-25-1992\n");

    if (openfile(argc, argv))
	cod2tab();
    else
	tab2cod();

    fclose(fout);
    fclose(fin);
}
