/************************************************************************\
 *	{W: TBL2COD.C						*
 *	]pت: N BGI2DAYI.TBL ഫiŪr DAYI.COD 	*
 *	{  : vz (Unicorn)					*
 *	]p: 12-25-1992						*
\************************************************************************/

#include <stdio.h>

/**************************************
 *	~BzƵ{
 */
void errexit(int n)
{
    char *errmsg[] = {
	"BIG2DAYI.TBL can not open",
	"DAYI.COD can not open",
	"setvbuf failed",
	"fseek failed",
	"ftell failed",
	"Invalid data format"
    };

    fprintf(stderr,"\nError: %s ...\n", errmsg[n++]);
    exit(n);
}

/**************************************
 *	D{
 */
void main(void)
{
    FILE    *fin, *fout;
    const static char table[][2] = {	/* jXPL */
	{' ',0xaa}, {'A',0xdb}, {'B',0xd9}, {'C',0xd8},
	{'D',0xdd}, {'E',0xdc}, {'F',0xde}, {'G',0xdf},
	{'H',0xd5}, {'I',0xd4}, {'J',0xd6}, {'K',0xd7},
	{'L',0xd2}, {'M',0xd3}, {'N',0xd1}, {'O',0xd0},
	{'P',0xca}, {'Q',0xcb}, {'R',0xc9}, {'S',0xc8},
	{'T',0xcd}, {'U',0xcc}, {'V',0xce}, {'W',0xcf},
	{'X',0xc5}, {'Y',0xc4}, {'Z',0xc6}, {'.',0x91},
	{'/',0x90}, {'0',0x8a}, {'1',0x8b}, {'2',0x89},
	{'3',0x88}, {'4',0x8d}, {'5',0x8c}, {'6',0x8e},
	{'7',0x8f}, {'8',0x85}, {'9',0x84}, {';',0x87},
	{',',0x92}
    };
    char    ch;
    register int i, j, k, size;

    /* LX Title */
    fprintf(stderr, "TBL2COD --- Convert BIG2DAYI.TBL to DAYI.COD,"
		    " Version 12-25-1992\n");

    /* }ҿXPJɮ */
    if ((fin = fopen("big2dayi.tbl","rb")) == NULL)
	errexit(0);
    if ((fout = fopen("dayi.cod","wt")) == NULL)
	errexit(1);

    /* ]w I/O wİ */
    if (setvbuf(fin,NULL,_IOFBF,20480) != 0)
	errexit(2);
    if (setvbuf(fout,NULL,_IOFBF,20480) != 0)
	errexit(2);

    /* DX BIG2DAYI.TBL ɮפjp */
    if (fseek(fin,0,SEEK_END))
	errexit(3);
    if ((size = (ftell(fin) / 4)) < 0)
	errexit(4);
    rewind(fin);

    for (i = 0; i < size; i++) {

	/* XjX */
	for (j = 0; j < 4; j++) {
	    ch = fgetc(fin);
	    for (k = 0; k < 41 && table[k][1] != ch; k++);
	    if (k == 41)
		errexit(5);
	    if (ch != 0xAA)
		fputc(table[k][0], fout);
	}

	/* Xr, æCLX */
	k =  (i < 5401) ? i : i + 408;
	j = k / 157 + 0xA4;
	k %= 157;
	k += (k < 63) ? 0x40 : 0x62;
	fprintf(fout,"\t%c%c\n",j,k);
    }
    fclose(fout);
    fclose(fin);
}
